# -*- coding: Latin-1 -*-

from Tkinter import *
import Pmw
import tkFileDialog
import sys
import scipy.misc
import Image,ImageTk
import csv
import numpy

class Gn_Toplevel(Toplevel):
    "classe de base pour les import"
    def __init__(self, parent=None,winW=600, winH=400,over=1):#,tl=''):

        #self.title(tl)
        print 'la classe Generic_Toplevel se lance'
        
        Toplevel.__init__(self, bd=2, relief=SOLID)
        winTL_width=winW
        winTL_height=winH
        self.geometry("%dx%d+%d+%d"%(winTL_width, winTL_height, parent.winfo_rootx()+(parent.winfo_width()-winTL_width)/2,
                                     parent.winfo_rooty()+(parent.winfo_height()-winTL_height)/2))
        self.overrideredirect(over)

    def affInfoText(self, FenText, Txt='', lenMax=20):
        'si le nom de fichier et trop long pour l affichage on rogne en partant de la fin'
        
        'a modifier reprer le / en fin de texte et prendre ce qu il y a derrire'
        
        print' fct affInfoText lance '
        if Txt:
                infoTxt=Txt
                if(len(infoTxt) >lenMax):
                        infoTxt=infoTxt[-lenMax:]
                FenText.delete(0.0,END)
                FenText.insert(INSERT, infoTxt)

    def reset(self):
        print'fct reset lance'

    def open(self):
        print'fct open lance'

    def close(self):
        print'fct close lance'
        Toplevel.destroy(self)

    def detroy(self):
        print'fct close lance'


class Win_message(Gn_Toplevel):
    "classe Win_message affichage d'information"
    def __init__(self, parent=None, message='None', color='red', winW=200, winH=100):

            Gn_Toplevel.__init__(self,parent,winW,winH)

            frame=Frame(self, bd=2,relief=GROOVE)
            frame.pack(padx= 5, pady=5, fill = 'both', expand=1)

            Label(frame, text=message, fg=color).pack(side='top', pady=10, fill = 'both')
            Button(frame, text="close", relief=GROOVE, width=10, command=self.close).pack(side='top', padx = 5, pady = 10)



class Win_importCSV(Gn_Toplevel):
    "classe de gestion de l'import csv"
    def __init__(self, parent=None):

        print 'la classe Win_importCSV se lance'
        Gn_Toplevel.__init__(self,parent,450,250)

        """winTL_width=600
        winTL_height=400
        Toplevel.__init__(self,bd=2,relief=SOLID)
        self.geometry("%dx%d+%d+%d"%(winTL_width, winTL_height, parent.winfo_rootx()+(parent.winfo_width()-winTL_width)/2,
                                     parent.winfo_rooty()+(parent.winfo_height()-winTL_height)/2))"""

        #CSV

        self.bg_TEXT='grey'
        self.bg_BG='white'

        self.refCSV=''
        self.refTILESET=''

        frame=Frame(self, bd=2,relief=GROOVE)
        frame.pack(padx= 5, pady=5, fill = 'both', expand=1)

        CSVgrp=Pmw.Group(frame, tag_text='--FICHIER CSV--')
        CSVgrp.pack(side = 'top', padx = 5, pady =5, fill = 'both', expand=1)
        
        frame_FileCSV=Frame(CSVgrp.interior())
        frame_FileCSV.pack(side = 'left', padx = 10, pady = 0)#, fill = 'both', expand = 1)
        
        Button(frame_FileCSV, text="...", relief=GROOVE, width=3, command=self.selectCSV).pack(side='left', padx = 5, pady = 10)
        #info_CSV = Label(CSVgrp.interior(), text = 'import type : hhhhhhhhhhhhh')
        self.txt_CSV=Text(frame_FileCSV, height= 1, width=20, bg=self.bg_BG, fg=self.bg_TEXT)
        #info_CSV.insert(INSERT, "Hello")
        self.txt_CSV.insert(INSERT,'file ...')
        #info_CSV.delete(0.0,END)
        #info_CSV.insert(END, "Hello.....gggggggggggggggggggggggggggggg")
        self.txt_CSV.pack(side='left')
        #info_CSV.grid(row=0,column=0,sticky=W)
        #Button(CSVgrp.interior(), text="select CSV", relief=GROOVE, width=10, command=Gn_Toplevel.open).pack(side='left', padx = 5, pady = 10)

        TILESETgrp=Pmw.Group(frame, tag_text='--TILESET--')
        TILESETgrp.pack(side = 'top', padx = 5, pady =5, fill = 'both', expand=1)

        frame_FileTILE=Frame(TILESETgrp.interior())
        frame_FileTILE.pack(side = 'left', padx = 10, pady = 0)#, fill = 'both', expand = 1)

        Button(frame_FileTILE, text="...", relief=GROOVE, width=3, command=self.selectTileset).pack(side='left', padx = 5, pady = 10)
        self.txt_TILE=Text(frame_FileTILE, height= 1, width=20, bg=self.bg_BG, fg=self.bg_TEXT)
        self.txt_TILE.insert(END, 'file ...')
        self.txt_TILE.pack(side='left')

        frame_HW=Frame(TILESETgrp.interior())
        frame_HW.pack(side = 'right', padx = 30, pady = 0)

        valNbrTilesEntry = '0'
        self.nbrTiles=Pmw.EntryField(frame_HW,labelpos = 'w',label_text = 'nbrTiles(facultatif)',validate = 'numeric',entry_width=5,value=valNbrTilesEntry)
        self.nbrTiles.pack(side='bottom', pady = 10)

        valTileCSVEntry = '8'
        self.tileH=Pmw.EntryField(frame_HW,labelpos = 'w',label_text = 'Tile Height',validate = 'numeric',entry_width=5, value=valTileCSVEntry)
        self.tileH.pack(side='bottom')
        self.tileW=Pmw.EntryField(frame_HW,labelpos = 'w',label_text = 'Tile Wight ',validate = 'numeric',entry_width=5, value=valTileCSVEntry)
        self.tileW.pack(side='bottom')

        #self.overrideredirect(1)# Supprime la dcoration.
        Button(frame, text="valider", relief=GROOVE, width=10, command=self.open).pack(side='right', padx = 5, pady = 10)
        Button(frame, text="gnrer", relief=GROOVE, width=10, command=self.open).pack(side='right', padx = 5, pady = 10)
        Button(frame, text="annuler", relief=GROOVE, width=10, command=self.close).pack(side='left', padx = 5, pady = 10)#, command=Gn_Toplevel.close)

    #def annule(self):
        #print'fct close lance'
        #self.master.win_ImportActive=0
        #Toplevel.destroy(self)
        
    def selectCSV(self):
        print'fct selectCSV lance'
        self.refCSV=tkFileDialog.askopenfilename(filetypes=[('CSV','*.csv')])
        #testTxt=self.affInfoText(self.refCSV)
        ##self.txt_CSV.delete(0.0,END)
        ##self.txt_CSV.insert(INSERT, self.affInfoText(self.refCSV))
        self.affInfoText(self.txt_CSV, self.refCSV)
        #print 'testTxt : '+testTxt
        #self.grab_set()
        self.focus_set()
        #self.focus_force()

        #test--------------------------
        """print'len(self.refCSV) : '+str(len(self.refCSV))
        fichier=fichier = open(self.refCSV,'rb')
        fichiercsv = csv.reader(fichier, delimiter=',')
        #fichiercsv = csv.reader(fichier, delimiter='\n')
        print 'fichiercsv typ : '+ str(type(fichiercsv))
        liste = []
        for row in fichiercsv:
                #print ', '.join(row[0])
                liste.append(row)
        #print 'fichier'+ str(fichiercsv)
        print liste[0][0]
        print 'len(liste[0]) : '+str(len(liste[0]))
        print 'len(liste) : '+str(len(liste))"""
        #test--------------------------

    def selectTileset(self):
        print'fct selectTileset lance'
        #self.refTILESET=tkFileDialog.askopenfilename(filetypes=[("Bilddateien", "*.png *.jpg *.gif *.jpeg")])
        self.refTILESET=tkFileDialog.askopenfilename(filetypes=[("Image Files", ("*.png","*.jpg", "*.gif")),("PNG",'*.png'),("JPEG",'*.jpg'),("GIF",'*.gif')])
        #self.txt_TILE.insert(INSERT,self.refTILESET)
        self.affInfoText(self.txt_TILE, self.refTILESET)
        #self.grab_set()
        self.focus_set()
        #self.focus_force()

    def open(self):
        print'fct openCSV lance'
        
        if(self.refCSV and self.refTILESET):

                self.master.name_FichierCSV=self.refCSV
                self.master.name_FichierTILESET=self.refTILESET

                self.CSV=open(self.refCSV,'rb')
                fichiercsv = csv.reader(self.CSV, delimiter=',')
                #fichiercsv = csv.reader(self.refCSV, delimiter=',')
                liste = []
                for row in fichiercsv:
                        #print ', '.join(row[0])
                        liste.append(row)
                #print 'liste : '+str(liste)

                self.master.list_importCSV=liste
                self.master.list_impCSV_Width=len(liste[0])
                self.master.list_impCSV_Height=len(liste)

                self.image = Image.open(self.refTILESET)
                #print'###########self.image : '+str(self.image.size)
                self.master.list_importTileSet=self.master.parse_TILESET(self.image,int(self.tileW.get()),int(self.tileH.get()),int(self.nbrTiles.get()))
                #self.master._importTileW=int(self.tileW.get())
                #self.master._importTileH=int(self.tileH.get())

                self.master.state_btGenerate()
                self.master.typeImport='CSV'
                self.close()

        else:
                #print 'open CSV --> else'
                Win_message(self,'selectionner les fichiers')

    def close(self):
        print'fct close lance'
        self.master.win_ImportActive=0
        Toplevel.destroy(self)



"""class Win_importIMAGE(Gn_Toplevel):
    "classe de gestion de l'import image"
    def __init__(self, parent=None):

        print 'la classe Win_importIMAGE se lance'
        Gn_Toplevel.__init__(self,parent,600,200)

        frame=Frame(self, bd=2,relief=GROOVE)
        frame.pack(padx= 5, pady=5, fill = 'both', expand=1)
        IMGgrp=Pmw.Group(frame, tag_text='--FICHIER BITMAP--')
        IMGgrp.pack(side = 'top', padx = 5, pady =5, fill = 'both', expand=1)
        Button(frame, text="ouvrir", relief=GROOVE, width=10).pack(side='right', padx = 5, pady = 10)
        Button(frame, text="annuler", relief=GROOVE, width=10, command=self.close).pack(side='left', padx = 5, pady = 10)

    def close(self):
        print'fct close lance'
        self.master.win_ImportActive=0
        Toplevel.destroy(self)"""



class Win_importTILESET(Gn_Toplevel):
    "classe de gestion de l'import image"
    def __init__(self, parent=None):

        print 'la classe Win_importTILESET se lance'
        Gn_Toplevel.__init__(self,parent,450,180)

        self.typeImport='TILESET'
        self.bg_TEXT='grey'
        self.bg_BG='white'
        self.refTILESET=''
        valTileEntry = '8'

        frame=Frame(self, bd=2,relief=GROOVE)
        frame.pack(padx= 5, pady=5, fill = 'both', expand=1)
        TILESETgrp=Pmw.Group(frame, tag_text='--TILESET--')
        TILESETgrp.pack(side = 'top', padx = 5, pady =5, fill = 'both', expand=1)

        frame_FileTILE=Frame(TILESETgrp.interior())
        frame_FileTILE.pack(side = 'left', padx = 10, pady = 0)#, fill = 'both', expand = 1)

        Button(frame_FileTILE, text="...", relief=GROOVE, width=3, command=self.selectTileset).pack(side='left', padx = 5, pady = 10)
        self.txt_TILE=Text(frame_FileTILE, height= 1, width=20, bg=self.bg_BG, fg=self.bg_TEXT)
        self.txt_TILE.insert(END, 'file ...')
        self.txt_TILE.pack(side='left')

        frame_tileHW=Frame(TILESETgrp.interior())
        frame_tileHW.pack(side = 'right', padx = 30, pady = 0)

        valNbrTilesEntry = '0'
        self.nbrTiles=Pmw.EntryField(frame_tileHW,labelpos = 'w',label_text = 'nbrTiles(facultatif)',validate = 'numeric',entry_width=5,value=valNbrTilesEntry)
        self.nbrTiles.pack(side='bottom', pady = 10)

        self.tileH=Pmw.EntryField(frame_tileHW,labelpos = 'w',label_text = 'Tile Height',validate = 'numeric',entry_width=5, value=valTileEntry)
        self.tileH.pack(side='bottom')
        self.tileW=Pmw.EntryField(frame_tileHW,labelpos = 'w',label_text = 'Tile Wight ',validate = 'numeric',entry_width=5, value=valTileEntry)
        self.tileW.pack(side='bottom')

        Button(frame, text="ouvrir", relief=GROOVE, width=10, command=self.open).pack(side='right', padx = 5, pady = 10)
        Button(frame, text="annuler", relief=GROOVE, width=10, command=self.close).pack(side='left', padx = 5, pady = 10)

    def selectTileset(self):
        print'fct selectTileset lance'
        #self.refTILESET=tkFileDialog.askopenfilename(filetypes=[("Bilddateien", "*.png *.jpg *.gif *.jpeg")])
        self.refTILESET=tkFileDialog.askopenfilename(filetypes=[("Image Files", ("*.png","*.jpg")),("PNG",'*.png'),("JPEG",'*.jpg')])
        self.affInfoText(self.txt_TILE, self.refTILESET)
        #self.txt_TILE.insert(INSERT,self.refTILESET)
        self.grab_set()
        self.focus_set()

    def open(self):
        print'fct open lance'

        if(self.refTILESET):


                self.master.name_FichierTILESET=self.refTILESET
                #print 'self.master.name_FichierTILESET : '+ self.master.name_FichierTILESET
                self.image = Image.open(self.refTILESET)
                
                #print 'type(self.refTILESET) : '+ str(type(self.master.name_FichierTILESET))
                self.master.list_importTileSet=self.master.parse_TILESET(self.image,int(self.tileW.get()),int(self.tileH.get()),int(self.nbrTiles.get()))
                #print 'self.master.list_importTileSet : '+str(self.master.list_importTileSet)
                #self.master._importTileW=int(self.tileW.get())
                #self.master._importTileH=int(self.tileH.get())
                #print 'self.master._importTileW : '+str(self.master._importTileW)
                #self.master.parse_TILESET(self.refTILESET,int(self.tileW.get()),int(self.tileH.get()),int(self.nbrTiles.get()))
                self.master.open_winTILESET(self.typeImport,self.master.list_importTileSet)
                self.master.TYPE_IMPORT=self.typeImport
                self.close()
        else:
                Win_message(self,'selectonner un fichier')

    def close(self):
        print'fct close lance'
        self.master.win_ImportActive=0
        Toplevel.destroy(self)



class Win_TILESET(Gn_Toplevel):
    "classe de gestion des tilesets"
    def __init__(self, parent=None, type_save='TOUTE', listTs=None, ListCSV=None, canvasColor='grey40'):

        print 'la classe Win_TILESET se lance'
        #Gn_Toplevel.__init__(self,parent,800,400,0)
        Gn_Toplevel.__init__(self,parent,800,500,0)

        #definie les sauvegarde possible en fonction de l'import: CSV,MAP, ou TILESET
        self.type_save_autorise=type_save


        #self.ListTs=listTs
        self.column=1
        self.gap=0#espacement entre les tuile
        self.borderGap=0#si l'espacement s'applique a partir du bord

        #tile un et deux pour les changements de place, la trois pour les tile neutre
        self.selectRect_width=2

        self.color_first='green'
        self.selectRect_first=None
        self.click_Idd_first=None
        self.Tile_first=None

        self.color_two='red'
        self.selectRect_two=None
        self.click_Idd_two=None
        self.Tile_two=None

        self.color_three='yellow'
        self.selectRect_three=None
        self.click_Idd_three=None
        self.Tile_three=None

        frame_TS=Frame(self, bd=2,relief=GROOVE)
        frame_TS.pack(padx= 0, pady=0, fill = 'both', expand=1)

        Grp_OPT = Pmw.Group(frame_TS, tag_text=' OPTIONS ')
        #Grp_OPT.pack(padx = 5, pady = 5, fill = 'both', expand = 1)
        Grp_OPT.pack(padx = 5, pady = 0, fill = 'x', expand = 1)

        Button(Grp_OPT.interior(), text=' reset ', relief=GROOVE, width=15, command=self.reset_Tile).pack(side='right', padx = 10, pady = 10)
        Button(Grp_OPT.interior(), text=' configure ', relief=GROOVE, width=15, command=self.config).pack(side='right', padx = 10, pady = 10)

        frame_entry=Frame(Grp_OPT.interior())
        frame_entry.pack(side = 'left', padx = 20, pady = 10)

        self.borderGrap=Pmw.EntryField(frame_entry,labelpos = 'w',value=self.borderGap, label_text = 'Border',validate = 'numeric',entry_width=5)#, value=valTileCSVEntry)
        self.borderGrap.pack(side='right', padx = 5, pady = 0)
        self.grap=Pmw.EntryField(frame_entry,labelpos = 'w',value=self.gap, label_text = 'Grap',validate = 'numeric',entry_width=5)#, value=valTileCSVEntry)
        self.grap.pack(side='right', padx = 5, pady = 0)
        self.column=Pmw.EntryField(frame_entry,labelpos = 'w',value=self.column ,label_text = 'Columns',validate = 'numeric',entry_width=5)#, value=valTileCSVEntry)
        self.column.pack(side='right', padx = 5, pady = 0)

        frame_tool=Frame(frame_TS, bd=2,relief=GROOVE)
        frame_tool.pack(side = 'left', padx= 5, pady=5, fill = 'both', expand=0)
        Button(frame_tool, text="gouper", relief=GROOVE, width=10, command=Gn_Toplevel.open).pack(side='top')

        # canvas MAP ###
        self.sc_tile = Pmw.ScrolledCanvas(frame_TS,borderframe = 1,labelpos = 'n', canvas_bg=canvasColor,
                                         usehullsize = 1,hull_width = 600,hull_height = 250)
        self.sc_tile.configure(vscrollmode ='static', hscrollmode='static')

        #self.sc_tile.tag_bind('image', '<Double-Button-1>', self.double_click)
        self.sc_tile.tag_bind('image', '<Button-1>', self.left_click)
        self.sc_tile.tag_bind('image', '<Button-3>', self.right_click)

        self.sc_tile.pack(padx = 5, pady = 0, fill = 'both', expand = 1)

        # menu info ###
        win_INFO = Pmw.Group(frame_TS, tag_text='INFO')
        win_INFO.pack(padx = 5, pady = 5, fill = 'both', expand = 1)

        frame_BT=Frame(frame_TS)#, bd=2,relief=GROOVE)
        frame_BT.pack(padx= 5, pady=5, fill = 'both')#padx= 5, pady=5, fill = 'both', expand=1)

        #Button(frame_BT, text="sauver", relief=GROOVE, width=10, command=self.save).pack(side='right')
        #Button(frame_BT, text="annuler", relief=GROOVE, width=10, command=self.close).pack(side='left')

        #selectionne les type de sauvegarde possible
        self.type_save_autorise
        #type_save='TILESET'
        #type_save_autorise='TOUTE'

        bt_save= Menubutton(frame_BT, text='Save', relief=RAISED, width=10)
        bt_save.pack(side='right')
        me2=Menu(bt_save)
        #self.SAVE_TYPE_tileset=me2.add_command(label ='save Tileset', underline =0)
        #self.SAVE_TYPE_csv=me2.add_command(label ='save CSV+Tileset', underline =0)
        #self.SAVE_TYPE_xml=me2.add_command(label ='save XML+Tileset', underline =0)
        me2.add_command(label ='save Tileset', underline =0)
        if(self.type_save_autorise !='TILESET'):
                me2.add_command(label ='save CSV+Tileset', underline =0)
                me2.add_command(label ='save XML+Tileset', underline =0)
        bt_save.configure(menu= me2)

        #self.state_typeSave(0,0,0)

        Button(frame_BT, text="annuler", relief=GROOVE, width=10, command=self.close).pack(side='left')

        self.init(listTs)

    def init(self,listTs=None):
        print'fct init lance'

        if(listTs):
                #print 'type(listTs) : '+str(type(listTs))
                self.ListTs=listTs
                #print 'index self.ListTs.index(0) : '+str(self.ListTs.index(0))
                #print 'type(self.ListTs) : '+str(type(self.ListTs))
                self.TsW, self.TsH =self.ListTs[0].shape[0],self.ListTs[0].shape[1]

                print 'self.TsW, self.TsH : '+str(self.TsW) +' , '+str( self.TsH)
                #self.TsW, self.TsH=40,40

                self.Tiles_cs=len(listTs)
                #liste des tiles dans le canvas
                self.List_TileCs=self.Tiles_cs*[None]

                print ' len(self.List_TileCs) : '+str(len(self.List_TileCs))

                for i in range(self.Tiles_cs):

                        self.List_TileCs[i]=self.create_tile(self.ListTs[i],i,self.sc_tile,0)
                        self.List_TileCs[i].Id=self.sc_tile.create_image(0,0,anchor=NW,image=self.List_TileCs[i].image, tag='image')

                        self.sc_tile.resizescrollregion()

                self.drawTiles()
                #teste a enlever creation d'un rectangle
                #rect=self.sc_tile.create_rectangle(50, 50, self.TsW, self.TsH)#, state='hidden', fill='red')
                self.rect_select_first=self.sc_tile.create_rectangle(0, 0, self.TsW, self.TsH,width=self.selectRect_width, outline=self.color_first, state='hidden')#, fill='red')
                self.rect_select_two=self.sc_tile.create_rectangle(0, 0, self.TsW, self.TsH,width=self.selectRect_width, outline=self.color_two, state='hidden')#, fill='red')
                self.rect_select_three=self.sc_tile.create_rectangle(0, 0, self.TsW, self.TsH,width=self.selectRect_width, outline=self.color_three, state='hidden')#, fill='red')

                #test
                #self.selectRectfirst_Actifs(1)
                #self.selectRecttwo_Actifs(1)
                print'initialiser le bouton config'

    def create_tile(self,ImNumpy=None,idx=0,canvas=None,supp=0):
        #print'fct create_tilr lance'
        #ImNumpy le tableau passe a la classe, idx la position dans la liste fournis
        if ImNumpy != None:
                Tilecn=Tile_Canvas()
                return Tilecn.init(ImNumpy,idx,canvas,supp)

    def drawTiles(self,col=1,grap=0,bordergrap=0):
        print 'fct drawTiles se lance'

        for idx in range(len(self.List_TileCs)):
                #print'idxI de drawTiles : '+str(idxI)
                self.posTile(idx,col,grap,bordergrap)

    def posTile(self,numTile=0,col=1,grap=0,BordGrap=0):
        #print 'fct posTile se lance '
        tabI=int(numTile%col)
        tabJ=int(numTile/col)

        #self.List_TileCs[numTile].posX= (tabI*self.TsW)+(tabI*grap)+BordGrap
        self.List_TileCs[numTile].posX= tabI*(self.TsW+grap)+BordGrap

        #self.List_TileCs[numTile].posY= (tabJ*self.TsH)+(tabJ*grap)+BordGrap
        self.List_TileCs[numTile].posY= tabJ*(self.TsH+grap)+BordGrap

        #print 'self.List_TileCs[numTile].image : '+str(self.List_TileCs[numTile].image)
        self.sc_tile.coords(self.List_TileCs[numTile].Id, self.List_TileCs[numTile].posX, self.List_TileCs[numTile].posY)

        self.sc_tile.resizescrollregion()

    def state_selectRectangle(self,rectSelect=None,st=0,x=0,y=0):
            #st etat du rectangle visible invisible
            print'fct state_selectRectangle lance'

            self.sc_tile.coords(rectSelect, x, y, x+self.TsW, y+self.TsH)
            self.sc_tile.itemconfigure(rectSelect,state=['hidden','normal'][st])

    def right_click(self, event):
            print'fct right_click lance'

            if not(self.click_Idd_first):
                    iid = self.sc_tile.find_withtag('current')[0]
                    self.Tile_three=self.selectTile(iid)#idd l'indice de l'element dans le canvas
                    self.state_selectRectangle(self.rect_select_three, 1, self.Tile_three.posX, self.Tile_three.posY)

                    self.winTool=Win_ToolTileset(self,event,0,-50,1,self.Tile_three.destroy)

    def left_click(self, event):
            print'fct left_clcik lance'
            print'empecher a si le click droit a t dectect et inevrsement'

            iid = self.sc_tile.find_withtag('current')[0]
            print 'iid : '+str(iid)

            if self.click_Idd_first==None:
                    self.click_Idd_first=iid
                    self.Tile_first=self.selectTile(iid)
                    #self.selectRectfirst_Actifs(1,self.Tile_first.posX,self.Tile_first.posY)
                    self.state_selectRectangle(self.rect_select_first,1,self.Tile_first.posX,self.Tile_first.posY)

            elif iid==self.click_Idd_first:
                    print '*******first tile annule*******'
                    self.click_Idd_first=None
                    self.Tile_first=None
                    #self.selectRectfirst_Actifs(0)
                    self.state_selectRectangle(self.rect_select_first,0)
            elif iid != self.click_Idd_first:
                    self.click_Idd_two=iid
                    self.Tile_two=self.selectTile(iid)
                    #self.selectRecttwo_Actifs(1,self.Tile_two.posX,self.Tile_two.posY)
                    self.state_selectRectangle(self.rect_select_two,1,self.Tile_two.posX,self.Tile_two.posY)
                    #print 'event.x : '+str(event.x)
                    #print 'event.y : '+str(event.y)

                    self.winTool=Win_ToolTileset(self,event,0,-50)
                    #Win_ToolTileset(self,event,0,-50)

    def move_left(self):
            print'fct move_left lance'
            #self.selectTiles()

            self.move_Tile(0)

            self.state_selectRectangle(self.rect_select_first,0)
            self.state_selectRectangle(self.rect_select_two,0)
            self.reset_TilesSelect()
            self.winTool.close()

    def move_right(self):
            print'fct move_right lance'

            self.move_Tile(1)

            self.state_selectRectangle(self.rect_select_first,0)
            self.state_selectRectangle(self.rect_select_two,0)
            self.reset_TilesSelect()
            self.winTool.close()

    def move_invert(self):
            print'fct move_invert lance'

            self.invert_tile(self.Tile_first,self.Tile_two)

            self.state_selectRectangle(self.rect_select_first,0)
            self.state_selectRectangle(self.rect_select_two,0)
            self.reset_TilesSelect()
            self.winTool.close()

    def invert_tile(self,tile1,tile2):
            print'fct invert_tile lance'
            #change les coord et la position des tuile dans le canvas

            posLstFirst=self.List_TileCs.index(tile1)
            posLstTwo=self.List_TileCs.index(tile2)

            self.List_TileCs.insert(posLstTwo, self.List_TileCs.pop(self.List_TileCs.index(self.Tile_first)))
            self.List_TileCs.insert(posLstFirst, self.List_TileCs.pop(self.List_TileCs.index(self.Tile_two)))

            self.drawTiles(int(self.column.get()),int(self.grap.get()),int(self.borderGrap.get()))

    def move_Tile(self,pos=0):
            print'fct move_Tile lance'
            """replace une tile dans la liste"""

            #new_posLst=self.List_TileCs.index(self.Tile_two)+pos

            #print 'new_posLst : '+str(new_posLst)

            #print'self.List_TileCs.index(self.Tile_first) : '+str(self.List_TileCs.index(self.Tile_first))

            #self.List_TileCs.insert(new_posLst, self.List_TileCs.pop(self.List_TileCs.index(self.Tile_first)))
            if(pos==0):
                    new_posLst=self.List_TileCs.index(self.Tile_two)+pos
                    self.List_TileCs.insert(new_posLst, self.List_TileCs.pop(self.List_TileCs.index(self.Tile_first)))

            elif(pos==1):
                    pos1=self.List_TileCs.index(self.Tile_first)
                    pos2=self.List_TileCs.index(self.Tile_two)
                    new_posLst=pos2+pos
                    if(pos1>pos2):
                            #new_posLst=self.List_TileCs.index(self.Tile_two)+pos
                            self.List_TileCs.insert(new_posLst,self.List_TileCs.pop(self.List_TileCs.index(self.Tile_first)))
                    else:
                            #new_posLst=self.List_TileCs.index(self.Tile_two)+pos
                            self.List_TileCs.insert(new_posLst,self.Tile_first)
                            self.List_TileCs.pop(self.List_TileCs.index(self.Tile_first))


            self.drawTiles(int(self.column.get()),int(self.grap.get()),int(self.borderGrap.get()))

            #for i in self.List_TileCs[new_posLst:]:
                    #print'###################################### boucle lanc'
                    #i.posX,iposY=List_TileCs

    def white_right(self):
            print'fct white_right lance'
            self.create_whiteTile(1)

    def white_left(self):
            print'fct white_left lance'
            self.create_whiteTile(0)

    def white_supp(self):
            print'fct white_supp lance'

    def move_cancel(self):
            print'fct move_cancel lance'
            #print dir(event)
            self.reset_TilesSelect()
            self.winTool.close()

    def create_whiteTile(self,pos=0):
            print'fct create_whiteTile lance'


    def reset_Tile(self):
            print 'fct reseth_Tile'
            for idxI in range(len(self.List_TileCs)):
                    print'#'



    def config(self):
        print 'fct config se lance '
        self.drawTiles(int(self.column.get()),int(self.grap.get()),int(self.borderGrap.get()))

    """def selectTiles(self):
        print 'fct selectTiles se lance '
        #for i in range(len(self.List_TileCs)):
        print 'len(self.List_TileCs) : '+ str(len(self.List_TileCs))
        for i in self.List_TileCs:
                #print 'type(i) : '+str(type(i))
                if (i.Id==self.click_Idd_first) :
                        self.Tile_first=i
                elif (i.Id==self.click_Idd_two) :
                        self.Tile_two=i
                elif (self.Tile_first and self.Tile_two):
                        break"""

    def selectTile(self,id):
        print 'fct selectTile se lance '
        #for i in range(len(self.List_TileCs)):
        #print 'len(self.List_TileCs) : '+ str(len(self.List_TileCs))
        for tile in self.List_TileCs:
                #print 'type(i) : '+str(type(i))
                if (tile.Id==id):
                        return tile


    def reset_TilesSelect(self):
        print 'fct reset_TilesSelect se lance '

        self.click_Idd_first=None
        self.Tile_first=None
        self.click_Idd_two=None
        self.Tile_two=None
        self.click_Idd_three=None
        self.Tile_three=None

        self.state_selectRectangle(self.rect_select_first,0)
        self.state_selectRectangle(self.rect_select_two,0)
        self.state_selectRectangle(self.rect_select_three,0)

    def state_typeSave(self,tileset=1,csv=1,xml=1):
        print'fct state_typeSave lance'
        #self.SAVE_TYPE_tileset.configure(state=['disable','normal'][tileset])
        #self.SAVE_TYPE_csv=me2.configure(state=['disable','normal'][csv])
        #self.SAVE_TYPE_xml=me2.configure(state=['disable','normal'][xml])

    def save(self):
        print'fct save lance'

    def close(self):
        print'fct close lance'
        self.master.win_ImportActive=0
        Toplevel.destroy(self)




class Tile_Canvas():
    "classe li win_TileSet"
    def __init__(self):

            #print 'la classe Tile_Canvas se lance'

            self.image=None
            self.Id=0#indice de l'image dans le canvas
            self.posTsOrigin=0
            self.posX, self.posY=0,0
            self.destroy=0

    def init(self,imNumpy=None,posT=0,canvas=None,supp=0):
            #print 'fct init lance'
            #imNumpy l'array numpy a transforme en image

            #destroy ne sert que pour les tileblanche que l'on peut enlever

            im=scipy.misc.toimage(imNumpy)
            self.image= ImageTk.PhotoImage(im)
            self.posTsOrigin=posT#position dans la liste de depart pour modiferle xml a la save
            self.canvas=canvas
            self.destroy=supp#savoir si c une tuile de depar, si oui indestructible

            return self



class Win_ToolTileset(Toplevel):
    "classe de gestion des toolTile"
    def __init__(self, parent=None,event=None,offX=0,offY=0,tileWhite=0,whiteSupp=0):
        # l'offset set au decalage par rapport a la souris

        #print 'la classe Win_ToolTileset se lance'
        Toplevel.__init__(self,parent)

        self.offsetX=offX
        self.offsetY=offY

        self.overrideredirect(1)

        self.grab_set()
        self.focus_set()

        frame_Bt=Frame(self, bd=2,relief=GROOVE)
        frame_Bt.pack(padx= 5, pady=5, fill = 'both', expand=1)

        self.iconeI=None

        images=('LEFT','RIGHT','INVERT','CANCEL')
        commands = {'LEFT':parent.move_left,'RIGHT':parent.move_right,'INVERT':parent.move_invert,'CANCEL':parent.move_cancel}

        #images_TileWhite=('LEFT','RIGHT','SUPP','CANCEL')
        images_TileWhite=['LEFT','RIGHT','CANCEL']
        commands_TileWhite = {'LEFT':parent.white_left,'RIGHT':parent.white_right,'SUPP':parent.white_supp,'CANCEL':parent.move_cancel}

        if(tileWhite):
                        if whiteSupp:
                                images_TileWhite[2:2]=['SUPP']
                                
                        self.initButtons(frame_Bt,images_TileWhite,commands_TileWhite)
        else:
                        self.initButtons(frame_Bt,images,commands)

        self.update()

        self.geometry("%dx%d+%d+%d"%(self.winfo_width(), self.winfo_height(), parent.winfo_rootx()+parent.sc_tile.winfo_x()+event.x-(self.winfo_width()/2)+self.offsetX , 
                                     parent.winfo_rooty()+parent.sc_tile.winfo_y()+event.y+self.offsetY))

    def initButtons(self,parent,lstImages,lstCommands=None):
            print'fct initButton lance'

            nbBou=len(lstImages)
            self.iconeI=[None]*nbBou
            for b in range(nbBou):
                    self.iconeI[b]=PhotoImage(file=lstImages[b]+'.gif')
                    bou= Button(parent, image=self.iconeI[b], relief=GROOVE)
                    if lstCommands :
                            bou["command"] = lstCommands[lstImages[b]]
                    bou.pack(side=LEFT)

    def close(self):
        print'##################fct close de winTool lance'
        #self.master.win_ImportActive=0
        Toplevel.destroy(self)






"""class BufferCSV():
    "classe li au parse CSV, cree un buffer"
    def __init__(self):
            print 'la classe BufferCSV se lance'

    def creatBuffer():"""


class TileBuffer():
    "classe li au parse CSV"
    def __init__(self,tilex=0,tiley=0,posx=0,posy=0):

            #print 'la classe TileBuffer se lance'

            #self.posX, self.posY=0,0
            #self.TileX, self.TileY=0,0
            self.posX, self.posY=posx,posy
            self.TileX, self.TileY= tilex, tiley

    #def init(self,posx,posy,tileWidth, tileHeight):
            #print 'fct init lance'

            #self.posX, self.posY=posx,posy
            #self.TileX, self.TileY= posx*tileWidth, posy*tileHeight



class MainApp(Tk):
    "classe de lancement du programme"
    def __init__(self):
        Tk.__init__(self)
        self.title('-TILESET EDITOR-')
        print'class MainApp lance'

        #self.configure(width=200,height=100)
        #self.resizable(width=False,height=False)
        #self.geometry("800x600+300+0")

        #Frame de placement general du menu
        frameMenu =Frame (self)
        frameMenu.pack(side = 'top', padx = 5, pady = 0, fill = 'both', expand = 1)

        #---ATTRIBUTS--- #
        valTileGen_Entry = '8'
        self.state_PROJET=0 #savoir si un projet a t lanc
        self.win_ImportActive=0#une fenetre d'import est active
        self.image=0
        self.mapWidth, self.mapHeight=0,0 # en pixel
        self.editTileW, self.editTileH=0,0
        
        #self.refCSV=''#nom du fichier
        #self.refTILESET=''
        #self.refPICTURE=''
        self.TYPE_IMPORT=''

        self.name_FichierCSV=''#nom du fichier
        self.name_FichierTILESET=''
        self.name_FichierBITMAP=''

        self.list_importTileSet=[]#liste des elements apres l'import
        self._importTsW=0
        self._importTsH=0
        self._importTileW=0
        self._importTileH=0
        self._importTilesTsW=0
        self._importTilesTsH=0
        self._importTileMaxTs=0
        #self.tab_fichierTILESET
        self.tab_fichierBITMAP=''
        
        self.list_importCSV=[]
        self.list_impCSV_Width=0
        self.list_impCSV_Height=0

        self.list_exportTileSet=[]
        self.list_exportCSV=[]

        self.list_CSV=0#je les initialisent a 0, je sais pas encore quoi mettre

        self.importTileW, self.importTileH=0,0
        self.nbrImportTile=0
        
        self.listTile_EDIT=0

        #-------------- #

        # menu bouton import ###
        menu_Import = Pmw.Group(frameMenu, tag_text='  IMPORT  ')
        menu_Import.pack(side = 'left', padx = 5, pady =0, fill = 'both')

        ### bouton import
        #penser a le boucler
        bt_import= Menubutton(menu_Import.interior(), text='Fichier',relief=RIDGE)
        bt_import.pack(padx = 40, pady = 15)
        me1=Menu(bt_import)
        me1.add_command(label ='Tileset import', underline =0, command=self.open_importTILESET)
        me1.add_command(label ='map import', underline =0, command=self.open_importBITMAP)
        me1.add_command(label ='CSV(flixel) import', underline =0, command=self.open_importCSV)
        me1.add_separator()
        me1.add_command(label ='reset ', underline=0, command=self.reset)
        me1.add_separator()
        me1.add_command(label ='quitter ', underline=0, command=self.exit)
        bt_import.configure(menu= me1)


        # menu tile ###
        menu_Tile = Pmw.Group(frameMenu, tag_text='  TILE  ')
        menu_Tile.pack(side = 'right', padx = 5, pady = 0, fill = 'both', expand = 1)

        ### Frame de placement des entrees tile
        frame_TileEntry=Frame(menu_Tile.interior())
        frame_TileEntry.pack(side = 'left', padx = 0, pady = 0)#, fill = 'both', expand = 1)
        ### entre tile
        self.tileW=Pmw.EntryField(frame_TileEntry,labelpos = 'w',label_text = 'Tile Wight',value=valTileGen_Entry, validate = 'numeric',entry_width=5)
        self.tileW.grid(row=0,column=0,sticky=E,padx=15,pady=5)
        self.tileH=Pmw.EntryField(frame_TileEntry,labelpos = 'w',label_text = 'Tile Height',value=valTileGen_Entry,validate = 'numeric',entry_width=5)
        self.tileH.grid(row=1,column=0,sticky=E,padx=15,pady=5)

        #print 'self._real.getvalue() : '+self.tileW.getvalue()
        ### grille
        self.affGrille=IntVar(value=0)
        Checkbutton(menu_Tile.interior(), text='grille', variable=self.affGrille, command=self.Afficher_MAP).pack(side='left')

        ### Frame de placement dy bouton generate
        self.bg_COLOR='#d0d0b0'
        self.bg_BUTTON='#edc611'
        frame_BtGenerate=Frame(menu_Tile.interior(), bd=2,relief=GROOVE, bg=self.bg_COLOR)
        frame_BtGenerate.pack(side = 'right', padx= 15)
        ### bouton 'generate'
        self.btGen=Button(frame_BtGenerate, text="generate",bg=self.bg_BUTTON,state='disable',command=self.selectParse, bd=1,relief=SOLID)
        self.btGen.pack(side='right', padx = 5, pady = 10)
        Label(frame_BtGenerate,bg=self.bg_COLOR ,text="Rip Tilemap : ").pack(side='right', padx = 5, pady = 10)
        #self.state_btGenerate()


        # canvas MAP ###
        self.sc_map = Pmw.ScrolledCanvas(self,borderframe = 1,labelpos = 'n', canvas_bg='grey40',
                                         usehullsize = 1,hull_width = 700,hull_height = 400)
        self.sc_map.configure(vscrollmode ='static', hscrollmode='static')
        self.sc_map.pack(padx = 5, pady = 0, fill = 'both', expand = 1)

        # menu info ###
        win_INFO = Pmw.Group(self, tag_text='INFO')
        win_INFO.pack(padx = 5, pady = 5, fill = 'both', expand = 1)

        info_import = Label(win_INFO.interior(), text = 'import type : ')
        info_import.grid(row=0,column=0,sticky=W)
        info_map = Label(win_INFO.interior(), text = 'info map : ')
        #info_map.pack(side = 'top')
        info_map.grid(row=1,column=0,sticky=W)


    def open_importTILESET(self):
        print 'fct open_importTILESET lance(a implementer)'
        if( not( self.win_ImportActive)):
                self.win_ts=Win_importTILESET(self)
                self.win_ImportActive=1

    def open_importCSV(self):
        print 'fct open_importCSV lance'
        if( not( self.win_ImportActive)):
                self.win_import=Win_importCSV(self)
                self.win_ImportActive=1

    def open_importBITMAP(self):
        print 'fct open_importBITMAP lance'
        if( not( self.win_ImportActive)):
                self.name_FichierBITMAP = tkFileDialog.askopenfile(parent=self,mode='rb',title='Choose a file',
                                                                   filetypes=[("Image Files", ("*.png","*.jpg"))
                                                                              ,("PNG",'*.png'),("JPEG",'*.jpg')])
                self.openBMP = Image.open(self.name_FichierBITMAP)
                
                ###self.tab_fichierBITMAP=scipy.misc.fromimage(self.image)#test convertis une image en tab
                #self.image = scipy.misc.toimage(self.tab_fichierBITMAP)#test
                
                #self.mapWidth, self.mapHeight =self.image.size
                self.mapWidth, self.mapHeight =self.openBMP.size
                #print 'self.image.size : '+str(self.image.size)
                self.image= ImageTk.PhotoImage(self.openBMP)
                #self.image= ImageTk.PhotoImage(self.image)
                self.Afficher_MAP()

                self.state_btGenerate()

                self.typeImport='MAP'
                #self.tab_fichierBITMAP=scipy.misc.imread(self.name_FichierBITMAP)
                
                #afficheinfo
                #active bt generate

    def Afficher_MAP(self):
        print '*****fct Afficher_MAP lance *****'
        if (self.image) :
            self.sc_map.delete(ALL)
            self.item= self.sc_map.create_image(0,0,anchor=NW,image=self.image)
            self.sc_map.resizescrollregion()

            print 'self.tileWidth : ' + str(self.tileW.getvalue())
            print 'self.tileHeight : ' + str(self.tileH.getvalue())
            print'self.tileW.getvalue() : '+str(type(self.tileW.getvalue()))

            self.tW=int(self.tileW.getvalue())
            self.tH=int(self.tileH.getvalue())

            if (self.affGrille.get() and (self.tW and self.tH)):
            #if (self.affGrille.get() and (self.intTileW and self.intTileH)):
                self.Afficher_GRILLE()

    def Afficher_GRILLE(self):
        print '*****fct Afficher_GRILLE lance *****'
        #if(self.mapWidth % self.intTileW !=0 or self.mapHeight % self.intTileH !=0):
            #print 'la taille des tiles ne corespond pas au format de la map'

        a=0
        while(a<=self.mapWidth):
            self.sc_map.create_line(a, 0, a, self.mapHeight, width=1, fill='#5fbd31')
            a+=self.tW
        a=0
        while(a<=self.mapHeight):
            self.sc_map.create_line(0,a ,self.mapWidth,a, width=1, fill='#5fbd31')
            a+=self.tH

    def parse_TILESET(self,bitmap,TiW=0,TiH=0,tMax=0):
        print 'fct parse_TILESET lance'

        if bitmap :

                bmpTab=numpy.array(bitmap)

                if(TiW==0 and TiH==0):
                        
                        self._importTsW,self._importTsH=bitmap.size
                        self._importTileW,self._importTileH=bitamp.size
                        self._importTilesTsW=1
                        self._importTilesTsH=1
                        self._importTileMaxTs=1
                        return [bmpTab]

                print'bitmap.size : '+ str(bitmap.size)

                bmpW,bmpH=bitmap.size
                tilesBmpW=1
                tilesBmpH=1
                TileW=bmpW#si a taille des tuile est a 0 on lui associe la taille du bitmap
                TileH=bmpH#

                if(TiW and TiW < bmpW):

                        TileW=TiW
                        tilesBmpW=int(bmpW/TiW)

                if(TiH and TiH < bmpH):
                        TileH=TiH
                        tilesBmpH=int(bmpH/TiH)

                Tiles_gen=tilesBmpW*tilesBmpH

                if(tMax):
                        Tiles_gen=tMax

                #i=0

                listTs=[None]*Tiles_gen

                posX,posY=0,0
                """while i<Tiles_gen:

                        posX=int((i%tilesBmpW))*TileW
                        posY=int((i/tilesBmpW))*TileH

                        listTs[i]=bmpTab[posX:(posX+TileW), posY:(posY+TileH)]
                        
                        i+=1"""

                for i in range(Tiles_gen):
                        posX=int((i%tilesBmpW))*TileW
                        posY=int((i/tilesBmpW))*TileH
                        #print'posX, posY : '+str(posX)+' , '+str(posY)
                        listTs[i]=bmpTab[posY:(posY+TileH), posX:(posX+TileW)]

                self._importTsW,self._importTsH=bitmap.size
                self._importTileW=TileW
                self._importTileH=TileH
                self._importTilesTsW=tilesBmpW
                self._importTilesTsH=tilesBmpH
                self._importTileMaxTs=Tiles_gen

                return listTs




    def parse_BITMAP(self,bitmap=None,tiW=0,tiH=0):

        print 'fct parse_BITMAP lance'
        print'type(bitmap) : '+str(type(bitmap))
        #if(bitmap !=None):
        if(bitmap):
                bmpW,bmpH=bitmap.size
                print'bmpW,bmpH : '+str(bmpW)+' , '+str(bmpH)
                print'en debut de fonction tiW, tiH : '+str(tiW)+', '+str(tiH)
                #bmpW,bmpH=bitmap.width(),bitmap.height()
                bmpData=scipy.misc.fromimage(bitmap)#test convertis une image en tab
                print'type(bmpData) : '+str(type(bmpData))
                #bmpData=bitmap.getdata()
                #bmpTab=numpy.array(bmpData)
                if(tiW==0 and tiH==0):
                        self.list_importTileSet=[bmpData]
                        #print 'type(self.list_importTileSet) : '+str(type(self.list_importTileSet))
                        self.list_importCSV=[1]#a voir 
                        percent=100
                        #return [bmpTab]#on retourne rien le tableau et mie dans une variable

                tilesBmpW=1#nbre de tile sur la largeur
                tilesBmpH=1
                TileW=bmpW#si a taille des tuile est a 0 on lui associe la taille du bitmap
                TileH=bmpH#

                if(tiW and tiW < bmpW):
                                TileW=tiW
                                tilesBmpW=int(bmpW/tiW)
                if(tiH and tiH < bmpH):
                                TileH=tiH
                                tilesBmpH=int(bmpH/tiH)

                nbrMax=tilesBmpW*tilesBmpH
                print'nbrMax : '+str(nbrMax)
                print'tilesBmpW : '+str(tilesBmpW)
                print'tilesBmpH : '+str(tilesBmpH)
                print'TileW, TileH : '+str(TileW)+','+str(TileH)

                #tilePercent=int(100/nbrMax)
                tilePercent=100/nbrMax
                print'tilePercent : '+str(tilePercent)

                i=0
                result=0
                posX,posY=0,0
                percent=0
                listBmp=[]

                #creation du CSV
                #on cree une liste vide
                #totalTileCsv=0

                listCSV = tilesBmpH*[0]  ## peu importe ce que l'on met dans cette liste
                print'len(listCSV) : '+str(len(listCSV))
                for i in range(len(listCSV)):
                        listCSV[i] = tilesBmpW*[0]
                        #totalTileCsv +=len(listCSV[i])
                
                #print'totalTileCsv : '+str(totalTileCsv)

                #print'avant la boucle posX, posY : '+str(posX)+','+str(posY)

                for i in range(nbrMax):
                        #print'i : '+str(i)

                        numTileX=int((i%tilesBmpW))
                        numTileY=int((i/tilesBmpW))

                        #posX=numTileX*TileW
                        #posY=numTileY*TileH
                        posX=numTileX*TileW
                        posY=numTileY*TileH

                        #print'posX, posY : '+str(posX)+','+str(posY)

                        #TileEnCours=bmpData[posX:(posX+TileW), posY:(posY+TileH)]
                        TileEnCours=bmpData[posY:(posY+TileH),posX:(posX+TileW)]

                        #for imtab in listBmp:
                        for idx in range(len(listBmp)):

                                result=numpy.array_equal(TileEnCours,listBmp[idx])
                                #print'result : '+str(result)

                                if(result==True):

                                        listCSV[numTileY][numTileX]=idx
                                        #listCSV[numTileX][numTileY]=idx
                                        break
                        else:
                                listBmp.append(TileEnCours)
                                #listCSV[numTileX][numTileY]=listBmp.index(TileEnCours)
                                listCSV[numTileY][numTileX]=len(listBmp)-1
                                #listCSV[numTileX][numTileY]=len(listBmp)

                        percent+=tilePercent
                        #print'percent : '+str(percent)+' %'


                percent=100#le tilePercent peut etre un arrondie
                #la list CSV n'est pas renvoy??
                #on place les element dircetement dans la gene?
                #return listBmp
        self.list_importTileSet=listBmp#faut il les placer dans les import ou les export??
        #print 'type(self.list_importTileSet) : '+str(type(self.list_importTileSet))
        self.list_importCSV=listCSV#a voir 
        #print 'listCSV : '+str(listCSV)





    #def parse_CSV(self, listTset,listCSV,tiW,tiH):
    def parse_CSV(self,LtTset, LtCSV, TWgen=0, THgen=0, direct_gen=0):
        print'--------------------------------------------------------'
        print 'fct parse_CSV lance'

        if(LtTset and LtCSV):

                #print'LtTset : '+str(LtTset)
                #print'LtCSV : '+str(LtCSV)

                #on rcupre les donnesdes deux liste tile et csv import
                
                #ListTset liste de bitmap donn sous forme de numpyarray
                #ListCSVimp le CSV qui lui est associ est qui permet de creer la map
                
                ListTset=LtTset
                TileWts,TileHts=LtTset[0].shape[0],LtTset[0].shape[1]
                Tiles_tsW=self._importTilesTsW#creer une classe tileset
                Tiles_tsH=self._importTilesTsH

                ListCSVimp=LtCSV
                Tiles_CSVimpW=len(ListCSVimp[0])
                Tiles_CSVimpH=len(ListCSVimp)
                CSVimpW=Tiles_CSVimpW*TileWts
                CSVimpH=Tiles_CSVimpH*TileHts

                print''
                print 'TileWts,TileHts : '+str(TileWts)+' , '+str(TileHts)
                print 'Tiles_tsW,Tiles_tsH : '+str(Tiles_tsW)+' , '+str(Tiles_tsH)
                print 'total Tiles_ts : '+str(Tiles_tsW*Tiles_tsH)

                print 'Tiles_CSVimpW, Tiles_CSVimpH : '+str(Tiles_CSVimpW)+' , '+str(Tiles_CSVimpH)
                #print 'LtCSV : '+str(LtCSV)
                print''
                print'-----------------------'

                #format des nouvelles tiles a generer a genrer
                TileWgen, TileHgen = TWgen, THgen
                print 'TileWgen, TileHgen : '+str(TileWgen)+' , '+str(TileHgen)

                print''

                a=1 #temp

                #if(not(direct_gen) and ((TileWgen !=0 and TileHgen !=0) and (TileWts != TileWgen or TileHts !=TileHgen))):
                if(a):#temp

                        print 'parse CSV se lance'

                        #mapGen
                        if(TileWgen==0):
                                TileWgen=TileWts
                        if(TileHgen==0):
                                TileHgen=TileHts

                        Tiles_mapGenW=int((len(ListCSVimp[0])*TileWts)/TWgen)
                        Tiles_mapGenH=int((len(ListCSVimp)*TileHts)/THgen)
                        nbrTiles_gen=Tiles_mapGenH*Tiles_mapGenW
                        lenW_mapGen=Tiles_mapGenW*TWgen
                        lenH_mapGen=Tiles_mapGenH*THgen

                        print 'Tiles_mapGenW,Tiles_mapGenH : '+str(Tiles_mapGenW)+' , '+str(Tiles_mapGenH)
                        print 'nbrTiles_gen : '+str(nbrTiles_gen)
                        print 'lenW_mapGen,lenH_mapGen : '+str(lenW_mapGen)+' , '+str(lenH_mapGen)
                        print'-----------------------'
                        print''

                        #liste de sortie
                        list_Tgen=[]#liste des tiles genere
                        list_CSVgen = Tiles_mapGenH*[0]#liste du CSV genere
                        for indexCSV in range(len(list_CSVgen)):#initialisation de la list CSVgen
                                list_CSVgen[indexCSV] = Tiles_mapGenW*[0]

                        list_TBuffer=[]#liste des tiles du buffer

                        #buffer
                        tilesBuffW=int(TileWgen/TileWts)+2#nombre de tile sur le buffer en x,y
                        tilesBuffH=int(TileHgen/TileHts)+2

                        if(tilesBuffW >Tiles_CSVimpW):
                                tilesBuffW=Tiles_CSVimpW

                        if(tilesBuffH >Tiles_CSVimpH):
                                tilesBuffH=Tiles_CSVimpH

                        print 'tilesBuffW, tilesBuffH apres ajustement : '+str(tilesBuffW)+' , '+str(tilesBuffH)

                        lenW_buffer=tilesBuffW*TileWts
                        lenH_buffer=tilesBuffH*TileHts
                        nbrTilesBuf=tilesBuffW*tilesBuffH

                        buffer = numpy.empty((lenH_buffer, lenW_buffer) + ListTset[0].shape[2:])

                        print 'lenW_buffer, lenH_buffer : '+str(lenW_buffer)+' , '+str(lenH_buffer)
                        print 'nbrTilesBuf : '+str(nbrTilesBuf)
                        print 'buffer size : '+str(buffer.shape)

                        #creation des tiles pourle buffer avec la classe TileBuffer
                        for i in range(nbrTilesBuf):

                                numTbuffX=int((i%tilesBuffW))#positon de base qu'on aditionne a celle de la tile haut gauchedu buffer
                                numTbuffY=int((i/tilesBuffW))
                                
                                posX=numTbuffX*TileWts#position dans le buffer (on ne le calcule u'ne fois)
                                posY=numTbuffY*TileHts
                                
                                list_TBuffer.append(TileBuffer(numTbuffX, numTbuffY, posX, posY))
                                
                        tilegenCibleX,tilegenCibleY=0,0#ne sert que pour initialiser le buffer au debut sera enlever par la suite
                        old_tileHG_x, old_tileHG_y=0,0
                       
                        #percent=0
                        #tilePercent=int(100/nbrTiles_gen)

                        #on genere une fois le buffer avant de commencer, commenant a zero le premier utilise le buffer
                        #a mettre en fonction drawBuffer()

                        #tuile en haut/gauche du buffer
                        tileHG_x=int((tilegenCibleX*TileWgen)/TileWts)#1er tuile en haut a gauche
                        tileHG_y=int((tilegenCibleY*TileHgen)/TileHts)
                        
                        for idxT in list_TBuffer:

                                tabTilex=idxT.TileX+tileHG_x
                                tabTiley=idxT.TileY+tileHG_y

                                numTile=ListCSVimp[tabTiley][tabTilex]


                                buffer[idxT.posY : idxT.posY+TileHts , idxT.posX : idxT.posX+TileWts]=ListTset[int(numTile)]
 
 
 
                        print'-------------boucle lance-----------------------'
                        print'------------------------------------------------'

                        for cibleY in range(Tiles_mapGenH):
                                for cibleX in range(Tiles_mapGenW):
                                        
                                        #tile a extraire
                                        temprefX=cibleX
                                        temprefY=cibleY
                                        
                                        #tileHG dans le buffer
                                        tileHG_x=int((temprefX*TileWgen)/TileWts)
                                        tileHG_y=int((temprefY*TileHgen)/TileHts)

                                        #le buffer depasse il de la map?
                                        if tileHG_x > Tiles_CSVimpW-tilesBuffW:
                                                tileHG_x=Tiles_CSVimpW-tilesBuffW

                                        if tileHG_y > Tiles_CSVimpH-tilesBuffH:
                                                tileHG_y=Tiles_CSVimpH-tilesBuffH
                                                
                                        #le buffer doit il est rafraichie
                                        #si le buffer est different on le rafraichie
                                        if(tileHG_x !=old_tileHG_x  or tileHG_y !=old_tileHG_y):

                                                old_tileHG_x, old_tileHG_y= tileHG_x, tileHG_y

                                                buffer = numpy.empty((lenH_buffer, lenW_buffer) + ListTset[0].shape[2:])
                                               
                                                for Tib in list_TBuffer:

                                                        #numero du graphique a placer
                                                        tabTilex=Tib.TileX+tileHG_x
                                                        tabTiley=Tib.TileY+tileHG_y
                                                        
                                                        numTile=ListCSVimp[tabTiley][tabTilex]
                                                        
                                                        buffer[Tib.posY : Tib.posY+TileHts, Tib.posX : Tib.posX+TileWts]=ListTset[int(numTile)]
                                                       
                                        Tx= (temprefX*TileWgen)-(tileHG_x*TileWts)
                                        Ty= (temprefY*TileHgen)-(tileHG_y*TileHts)
                                        
                                        TileEnCours=buffer[Ty:(Ty+TileHgen), Tx:(Tx+TileWgen)]

                                        for idxgen in range(len(list_Tgen)):
                                                #si la tile existe deja on la note dans le CSVgen
                                                result=numpy.array_equal(TileEnCours,list_Tgen[idxgen])
                                                if(result==True):
                                                
                                                        list_CSVgen[cibleY][cibleX]=idxgen
                                                        break
                                        else:
                                                #inon on l'ajout a la liste list_Tgen
                                                list_Tgen.append(TileEnCours)
                                                list_CSVgen[cibleY][cibleX]=len(list_Tgen)-1
                                                

                                        #percent+=tilePercent

                        #percent=100
                        #print'bouclage tilegen termine'
                        
                        self.list_importTileSet=list_Tgen#l'import n'est pasle bonne endroit ou le mettre car deja occup au
                        #momment de l'import
                        self.list_importCSV=list_CSVgen

                else:
                        print'on passe directement les les dossier tileset et CSV'

        #self.list_importTileSet=list_Tgen
        #self.list_importCSV=list_CSVgen
        
    def open_winTILESET(self,typeImport='TOUTE',list_impTs=None,list_impCSV=None):
        print 'fct open_winTILESET lance'
        self.win_ts=Win_TILESET(self,typeImport,list_impTs,list_impCSV)

    def reset(self):
        print 'fct reset lance'

        self.TYPE_IMPORT=''
        self.sc_map.delete(ALL)
        self.name_FichierCSV=''
        self.name_FichierTILESET=''
        self.name_FichierBITMAP=''
        del(self.list_importTileSet[:])
        self._importTileW=0
        self._importTileH=0
        del(self.list_importCSV[:])
        del(self.list_exportTileSet[:])
        del(self.list_exportCSV[:])
        self.state_btGenerate(0)
        
        self.list_exportTileSet=''
        self.list_exportCSV=''

    def state_btGenerate(self,st=1):
            print'fct state_btGenerate lance'
            self.btGen.configure(state=['disable','normal'][st])

    def selectParse(self):
           print'fct selectParse lance'

           if self.typeImport=='MAP':
                   print'parse Map lance'
                   self.parse_BITMAP(self.openBMP,int(self.tileW.get()),int(self.tileH.get()))
           elif self.typeImport=='CSV':
                   print'parse CSV lance'
                   self.parse_CSV(self.list_importTileSet, self.list_importCSV, int(self.tileW.get()), int(self.tileH.get()))

           self.open_winTILESET(self.typeImport,self.list_importTileSet,self.list_importCSV)

    def exit(self):
        print 'fct quit lance'
        sys.exit()



app=MainApp()
app.mainloop()